@import './_variables.scss';

$colorClasses: (
    border: 'border-color',
    bg: 'background-color'
);

.border {
    box-sizing: border-box;
    border: 1px solid;
    &-left {
        border-left: 1px solid;
    }
    &-top {
        border-top: 1px solid;
    }
    &-right {
        border-right: 1px solid;
    }
    &-bottom {
        border-bottom: 1px solid;
    }
    &-lg {
        border-width: 2px;
    }
    &-none {
        border: none;
    }
}

.border-radius {
    border-radius: 5px;
}

@each $color in map-keys($colors) {
    $color-value: map-get($colors, $color);
    .#{$color} {
        color: $color-value;
    }
    .hover-#{$color}:hover {
        color: $color-value;
    }
    .focus-#{$color}:focus {
        color: $color-value;
    }
    .active-#{$color}:active {
        color: $color-value;
    }
    .placeholder-#{$color}::placeholder {
        color: $color-value;
    }

    .hover-#{$color}\!:hover {
        color: $color-value !important;
    }
    .focus-#{$color}\!:focus {
        color: $color-value !important;
    }
    .active-#{$color}\!:active {
        color: $color-value !important;
    }
    .placeholder-#{$color}\!::placeholder {
        color: $color-value !important;
    }
    @each $class in map-keys($colorClasses) {
        $attr: map-get($colorClasses, $class);
        .#{$class}-#{$color} {
            #{$attr}: $color-value;
        }
        .#{$class}-hover-#{$color}:hover {
            #{$attr}: $color-value;
        }
        .#{$class}-focus-#{$color}:focus {
            #{$attr}: $color-value;
        }
        .#{$class}-active-#{$color}:active {
            #{$attr}: $color-value;
        }

        .#{$class}-#{$color}\! {
            #{$attr}: $color-value !important;
        }
        .#{$class}-hover-#{$color}\!:hover {
            #{$attr}: $color-value !important;
        }
        .#{$class}-focus-#{$color}\!:focus {
            #{$attr}: $color-value !important;
        }
        .#{$class}-active-#{$color}\!:active {
            #{$attr}: $color-value !important;
        }
    }
}
